resource "aws_dynamodb_table" "user" {
  name         = "user-${random_id.id.hex}"
  billing_mode = "PAY_PER_REQUEST"
  hash_key     = "id"
  attribute {
    name = "id"
    type = "S"
  }
}

resource "aws_dynamodb_table" "friend" {
  name         = "friend-${random_id.id.hex}"
  billing_mode = "PAY_PER_REQUEST"
  hash_key     = "userId1"
  range_key    = "userId2"
  attribute {
    name = "userId1"
    type = "S"
  }
  attribute {
    name = "userId2"
    type = "S"
  }
}

resource "aws_dynamodb_table" "post" {
  name         = "post-${random_id.id.hex}"
  billing_mode = "PAY_PER_REQUEST"
  hash_key     = "id"
  attribute {
    name = "id"
    type = "S"
  }
  attribute {
    name = "userId"
    type = "S"
  }
  attribute {
    name = "date"
    type = "N"
  }

  global_secondary_index {
    name            = "userId"
    hash_key        = "userId"
    range_key       = "date"
    projection_type = "ALL"
  }
}

resource "aws_dynamodb_table" "comment" {
  name         = "comment-${random_id.id.hex}"
  billing_mode = "PAY_PER_REQUEST"
  hash_key     = "id"
  attribute {
    name = "id"
    type = "S"
  }
  attribute {
    name = "postId"
    type = "S"
  }
  attribute {
    name = "date"
    type = "N"
  }

  global_secondary_index {
    name            = "postId"
    hash_key        = "postId"
    range_key       = "date"
    projection_type = "ALL"
  }
}


